package org.kevoree.library;

import org.kevoree.ContainerRoot;
import org.kevoree.api.service.core.script.KevScriptEngineFactory;
import org.kevoree.cloner.DefaultModelCloner;
import org.kevoree.framework.AbstractGroupType;
import org.kevoree.framework.KevoreePlatformHelper;
import org.kevoree.log.Log;
import java.net.Inet4Address;
import java.net.InterfaceAddress;
import java.net.NetworkInterface;
import java.util.Enumeration;

/**
 * Created with IntelliJ IDEA.
 * User: duke
 * Date: 09/11/12
 * Time: 07:41
 */
public class NodeNetworkHelper {

    public static void main(String[] args){
        getAddresses();

    }

    public static java.util.HashMap<String,String> getAddresses() {
        java.util.HashMap<String,String> addresses = new java.util.HashMap<String,String>();
        try {
            Enumeration<NetworkInterface> networkInterfaces = NetworkInterface.getNetworkInterfaces();
            while(networkInterfaces.hasMoreElements()){
                NetworkInterface networkInterface = networkInterfaces.nextElement();
                if (!networkInterface.isLoopback()) {
                      for(InterfaceAddress interfaceAddress : networkInterface.getInterfaceAddresses()){
                          if(interfaceAddress.getAddress() instanceof Inet4Address){
                              addresses.put(interfaceAddress.getAddress().getHostAddress(),networkInterface.getDisplayName());
                          }
                      }
                }
            }
        }
        catch(Exception e) {
            Log.error("", e);
        }
        return addresses;
    }


    public static ContainerRoot addNetworkProperty (ContainerRoot model, String nodeName ,java.util.HashMap<String,String> ips , KevScriptEngineFactory kevScriptEngineFactory) {
        for(String key : ips.keySet()){
            KevoreePlatformHelper.instance$.updateNodeLinkProp(model, nodeName, nodeName, org.kevoree.framework.Constants.instance$.getKEVOREE_PLATFORM_REMOTE_NODE_IP(), key, ips.get(key), 100);
            Log.info("add {} as IP of {}", key, nodeName);
        }
        return model;
    }

    private static DefaultModelCloner cloner = new DefaultModelCloner();

    public static ContainerRoot updateModelWithNetworkProperty (AbstractGroupType group) {
        Object ipObject = group.getDictionary().get("ip");
        ContainerRoot readWriteModel = cloner.clone(group.getModelService().getLastModel());
        if (ipObject != null && !ipObject.toString().equals("") && !ipObject.toString().equals("0.0.0.0")) {
            java.util.HashMap<String,String> addresses = new java.util.HashMap<String,String>();
            addresses.put(ipObject.toString(),"unknown-" + ipObject.toString());
            return addNetworkProperty(readWriteModel, group.getNodeName(),addresses, group.getKevScriptEngineFactory());
        } else {
            java.util.HashMap<String,String> addresses = getAddresses();
            if (!addresses.isEmpty()) {
                return addNetworkProperty(readWriteModel, group.getNodeName(), addresses, group.getKevScriptEngineFactory());
            } else {
                return null;
            }
        }
    }

}
